/*
                   y
                   |
                   |
                   | v5
                 3 +-----------------+ v6=(3,3,0)
                  /|                /|
                /  |              /  |
              /    |            /    |
            /      |          /      |
        v4 +-----------------+ v3    |
           |       |         |       |                    y
           |       |         |       |                    |
           |       |         |       | v7                 |
           |    v8 +---------|-------+------> x           |
           |      /          |      /3                    |
           |    /            |    /                       +-----> x
           |  /              |  /                        /
           |/                |/                         /
         3 +-----------------+                         /
         / v1=(0,0,3)        v2=(3,0,3)              z
       /
     /
    z
*/

public class MainCubes
{
   public static void main(String[] args)
   {
      // Create a Model object to hold the geometry.
      Model model = new Model();

      // Give the Model a model matrix.
      model.model2Identity();

       // Add the geometry to the Model
      Vertex v1 = new Vertex(0.0, 0.0, 3.0);
      Vertex v2 = new Vertex(3.0, 0.0, 3.0);
      Vertex v3 = new Vertex(3.0, 3.0, 3.0);
      Vertex v4 = new Vertex(0.0, 3.0, 3.0);
      Vertex v5 = new Vertex(0.0, 3.0, 0.0);
      Vertex v6 = new Vertex(3.0, 3.0, 0.0);
      Vertex v7 = new Vertex(3.0, 0.0, 0.0);
      Vertex v8 = new Vertex(0.0, 0.0, 0.0);
      Vertex v9 = new Vertex(1.5, 0.0, 1.5);  // center of the bottom face
      // Second cube.
      Vertex v11 = new Vertex(4.0, 0.0, 1.0);
      Vertex v12 = new Vertex(5.0, 0.0, 1.0);
      Vertex v13 = new Vertex(5.0, 1.0, 1.0);
      Vertex v14 = new Vertex(4.0, 1.0, 1.0);
      Vertex v15 = new Vertex(4.0, 1.0, 0.0);
      Vertex v16 = new Vertex(5.0, 1.0, 0.0);
      Vertex v17 = new Vertex(5.0, 0.0, 0.0);
      Vertex v18 = new Vertex(4.0, 0.0, 0.0);
      Vertex v19 = new Vertex(4.5, 0.0, 0.5);  // center of the bottom face

      // First cube.
      v1.setColor(1.0, 0.0, 0.0);
      v2.setColor(0.0, 1.0, 0.0);
      v3.setColor(0.0, 0.0, 1.0);
      Triangle t1 = new Triangle(v1, v2, v3);
      model.triangleList.add( t1 );  // front face

      v3.setColor(0.0, 0.0, 1.0);
      v4.setColor(0.0, 1.0, 0.0);
      v1.setColor(1.0, 0.0, 0.0);
      Triangle t2 = new Triangle(v3, v4, v1);
      model.triangleList.add( t2 );   // front face

      v4.setColor(1.0, 1.0, 0.0);
      v3.setColor(1.0, 1.0, 0.0);
      v6.setColor(1.0, 0.0, 0.0);
      Triangle t3 = new Triangle(v4, v3, v6);
      model.triangleList.add( t3 );   // top face

      v5.setColor(1.0, 1.0, 0.0);
      v6.setColor(1.0, 1.0, 0.0);
      v4.setColor(1.0, 1.0, 0.0);
      Triangle t4 = new Triangle(v6, v5, v4);
      model.triangleList.add( t4 );   // top face

      v2.setColor(0.0, 1.0, 1.0);
      v7.setColor(0.0, 1.0, 1.0);
      v6.setColor(0.0, 1.0, 1.0);
      Triangle t5 = new Triangle(v2, v7, v6);
      model.triangleList.add( t5 );   // right face

      v6.setColor(1.0, 1.0, 1.0);
      v3.setColor(0.0, 1.0, 1.0);
      v2.setColor(0.0, 1.0, 1.0);
      Triangle t6 = new Triangle(v6, v3, v2);
      model.triangleList.add( t6 );   // right face

      v8.setColor(1.0, 0.0, 0.0);
      v1.setColor(0.0, 1.0, 0.0);
      v4.setColor(0.0, 0.0, 1.0);
      Triangle t7 = new Triangle(v8, v1, v4);
      model.triangleList.add( t7 );   // left face

      v4.setColor(0.0, 0.0, 1.0);
      v5.setColor(0.0, 1.0, 0.0);
      v8.setColor(1.0, 0.0, 0.0);
      Triangle t8 = new Triangle(v4, v5, v8);
      model.triangleList.add( t8 );   // left face

      v8.setColor(1.0, 0.0, 0.0);
      v1.setColor(0.0, 1.0, 0.0);
      v4.setColor(0.0, 0.0, 1.0);
      Triangle t9 = new Triangle(v7, v8, v6);
      model.triangleList.add( t9 );   // back face

      v8.setColor(1.0, 0.0, 0.0);
      v1.setColor(0.0, 1.0, 0.0);
      v4.setColor(0.0, 0.0, 1.0);
      Triangle t10 = new Triangle(v6, v5, v8);
      model.triangleList.add( t10 );   // back face

      v8.setColor(1.0, 0.0, 0.0);
      v1.setColor(1.0, 0.0, 0.0);
      v4.setColor(1.0, 0.0, 0.0);
      Triangle t11 = new Triangle(v9, v1, v2);
      model.triangleList.add( t11 );   // bottom face

      v8.setColor(0.0, 1.0, 0.0);
      v1.setColor(0.0, 1.0, 0.0);
      v4.setColor(0.0, 1.0, 0.0);
      Triangle t12 = new Triangle(v9, v2, v7);
      model.triangleList.add( t12 );   // bottom face

      v8.setColor(0.0, 0.0, 1.0);
      v1.setColor(0.0, 0.0, 1.0);
      v4.setColor(0.0, 0.0, 1.0);
      Triangle t13 = new Triangle(v9, v7, v8);
      model.triangleList.add( t13 );   // bottom face

      v8.setColor(1.0, 1.0, 1.0);
      v1.setColor(1.0, 1.0, 1.0);
      v4.setColor(1.0, 1.0, 1.0);
      Triangle t14 = new Triangle(v9, v8, v1);
      model.triangleList.add( t14 );   // bottom face


      // Second cube.
      v11.setColor(1.0, 0.0, 0.0);
      v12.setColor(0.0, 1.0, 0.0);
      v13.setColor(0.0, 0.0, 1.0);
      t1 = new Triangle(v11, v12, v13);
      model.triangleList.add( t1 );  // front face

      v13.setColor(0.0, 0.0, 1.0);
      v14.setColor(0.0, 1.0, 0.0);
      v11.setColor(1.0, 0.0, 0.0);
      t2 = new Triangle(v13, v14, v11);
      model.triangleList.add( t2 );   // front face

      v14.setColor(1.0, 1.0, 0.0);
      v13.setColor(1.0, 1.0, 0.0);
      v16.setColor(1.0, 0.0, 0.0);
      t3 = new Triangle(v14, v13, v16);
      model.triangleList.add( t3 );   // top face

      v15.setColor(1.0, 1.0, 0.0);
      v16.setColor(1.0, 1.0, 0.0);
      v14.setColor(1.0, 1.0, 0.0);
      t4 = new Triangle(v16, v15, v14);
      model.triangleList.add( t4 );   // top face

      v12.setColor(0.0, 1.0, 1.0);
      v17.setColor(0.0, 1.0, 1.0);
      v16.setColor(0.0, 1.0, 1.0);
      t5 = new Triangle(v12, v17, v16);
      model.triangleList.add( t5 );   // right face

      v16.setColor(1.0, 1.0, 1.0);
      v13.setColor(0.0, 1.0, 1.0);
      v12.setColor(0.0, 1.0, 1.0);
      t6 = new Triangle(v16, v13, v12);
      model.triangleList.add( t6 );   // right face

      v18.setColor(1.0, 0.0, 0.0);
      v11.setColor(0.0, 1.0, 0.0);
      v14.setColor(0.0, 0.0, 1.0);
      t7 = new Triangle(v18, v11, v14);
      model.triangleList.add( t7 );   // left face

      v14.setColor(0.0, 0.0, 1.0);
      v15.setColor(0.0, 1.0, 0.0);
      v18.setColor(1.0, 0.0, 0.0);
      t8 = new Triangle(v14, v15, v18);
      model.triangleList.add( t8 );   // left face

      v18.setColor(1.0, 0.0, 0.0);
      v11.setColor(0.0, 1.0, 0.0);
      v14.setColor(0.0, 0.0, 1.0);
      t9 = new Triangle(v17, v18, v16);
      model.triangleList.add( t9 );   // back face

      v18.setColor(1.0, 0.0, 0.0);
      v11.setColor(0.0, 1.0, 0.0);
      v14.setColor(0.0, 0.0, 1.0);
      t10 = new Triangle(v16, v15, v18);
      model.triangleList.add( t10 );   // back face

      v18.setColor(1.0, 0.0, 0.0);
      v11.setColor(1.0, 0.0, 0.0);
      v14.setColor(1.0, 0.0, 0.0);
      t11 = new Triangle(v19, v11, v12);
      model.triangleList.add( t11 );   // bottom face

      v18.setColor(0.0, 1.0, 0.0);
      v11.setColor(0.0, 1.0, 0.0);
      v14.setColor(0.0, 1.0, 0.0);
      t12 = new Triangle(v19, v12, v17);
      model.triangleList.add( t12 );   // bottom face

      v18.setColor(0.0, 0.0, 1.0);
      v11.setColor(0.0, 0.0, 1.0);
      v14.setColor(0.0, 0.0, 1.0);
      t13 = new Triangle(v19, v17, v18);
      model.triangleList.add( t13 );   // bottom face

      v18.setColor(1.0, 1.0, 1.0);
      v11.setColor(1.0, 1.0, 1.0);
      v14.setColor(1.0, 1.0, 1.0);
      t14 = new Triangle(v19, v18, v11);
      model.triangleList.add( t14 );   // bottom face


      // Create the Scene object that we shall render
      Scene scene = new Scene();

      // Add the Model to the Scene.
      scene.modelList.add(model);

      // Give the Scene a view matrix.
      scene.view2Identity();

      // Give the scene a projection matrix.
      scene.proj2Identity();

      // Set up the scene's view frustum.
      double fov    = 60.0;
      double aspect = 1.0;
      double near   = 1.0;
      double far    = 20.0;
      scene.projPerspective(fov, aspect, near, far);

      // Set up the scene's "camera".
      double eyex=0,    eyey=0,    eyez=10;
      double centerx=0, centery=0, centerz=0;
      double upx=0,     upy=1,     upz=0;
      scene.viewLookAt(eyex,    eyey,    eyez,
                       centerx, centery, centerz,
                       upx,     upy,     upz);

      //System.err.println( scene.toString(3) );

      // Create a framebuffer to render our scene into.
      int vp_width  = 512;
      int vp_height = 512;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);
      // Give the framebuffer a nice background color.
      fb.clearFB(java.awt.Color.darkGray);
      // Render our scene into the frame buffer.
      (new SceneRender(scene, fb)).renderScene();
      // Save the resulting image in a file.
      fb.dumpFB2File( String.format("PPM_Cubes_Frame%02d.ppm", 0) );

      // Spin the model 360 degrees.
      for (int i = 1; i <= 36; i++)
      {
         // Rotate the model by 10 degrees.
         model.modelRotate(10, 0, 1, 0);
         // Render again.
         fb.clearFB(java.awt.Color.darkGray);
         (new SceneRender(scene, fb)).renderScene();
         fb.dumpFB2File(String.format("PPM_Cubes_Frame%02d.ppm", i));
      }
   }
}