/**
   Do the perspective division step of the pipeline.
*/

public class P7_Clip2NDC implements PipelineStage
{
   public P7_Clip2NDC()
   {
   }


   /**
      Walk the Model's list of Triangle objects
      and divide each of the coordinates in a
      vertex by its w coordinate, i.e.,
      (x, y, z, w) -> (x/w, y/w, z/w, 1).
   */
   public Model processModel(Model model)
   {
      for (Triangle t : model.triangleList)
      {
         t.v[0] = (t.v[0]).times( 1.0/(t.v[0].w) );
         t.v[1] = (t.v[1]).times( 1.0/(t.v[1].w) );
         t.v[2] = (t.v[2]).times( 1.0/(t.v[2].w) );
         //debug(t);
      }
      return model;
   }


   private void debug(Triangle t)
   {
      // print the (x,y) part of each vertex in the triangle
      System.err.printf("x=% 8.5f, y=% 8.5f, x=% 8.5f, y=% 8.5f, x=% 8.5f, y=% 8.5f\n",
                         t.v[0].x, t.v[0].y, t.v[1].x, t.v[1].y, t.v[2].x, t.v[2].y);
   }
}