/**
                   (0,h2,0)
                   +
                   |
                   |
                   |
                   |
                   |
                   |
                   |
                   |
           (0,0,0) +-----------------+ (h1,0,0)
                  /
                /
              /
            /
           +
           (0,0,h3)

   A triangle with vertices (h1, 0, 0), (0, h2, 0), and (0, 0, h3)
   relative to the origin.
*/

public class TriangleModel extends Model
{
   public TriangleModel(double h1, double h2, double h3)
   {
      super();

      // Create the triangles's geometry.
      Vertex v1 = new Vertex(h1,  0,  0);
      Vertex v2 = new Vertex(0,  h2,  0);
      Vertex v3 = new Vertex(0,   0, h3);

      // Give this triangle the appropriate normal vector.
      double length = Math.sqrt(h2*h2*h3*h3 + h1*h1*h3*h3 + h1*h1*h2*h2);
      v1.n = new Vector( h2*h3/length, h1*h3/length, h1*h2/length );
      v2.n = v1.n;
      v3.n = v1.n;

      Triangle t = new Triangle(v1, v2, v3);
      triangleList.add( t );
   }
}//TriangleModel